package CACache;
use strict;
use CAConfig;

my $cfgvars = {};
my $cacache;

# ======================================================================== _init

sub _init {
 return if exists $cfgvars->{datadir};
 $cfgvars = CAConfig::getvars();
 $cacache = $cfgvars->{datadir}."/".$cfgvars->{cacache};
}
# ======================================================================= readid

sub readid {
  _init();
  return undef if ! -e $cacache;
  open(CACHE, $cacache) || return undef;
  my $remote = $ENV{'REMOTE_ADDR'};
  my $mintime = time() - $cfgvars->{cachewindow};
  for(my $line = <CACHE>; $line ne undef; $line = <CACHE>) {
   chop($line);
   my ($ip, $id, $tm) = split(/\s+/, $line);
   last if $tm < $mintime;
   next if $remote ne $ip;
   close CACHE;
   return $id;
  }
  close CACHE;
  return undef;
}
# ====================================================================== writeid

sub writeid {
  _init();
  my @ids;
  if (! -e $cacache) {
    open(CACHE, ">$cacache") || return;
    eval "flock(CACHE, 2)";
  } else {
    open(CACHE, "+<$cacache") || return;
    eval "flock(CACHE, 2)";
    if (!seek(CACHE, 0, 0)) {
      close(CACHE);
      return;
    }
    @ids = <CACHE>;
    chomp(@ids);
  }
  if (!seek(CACHE, 0, 0)) {
    close(CACHE);
    return;
  }
  print CACHE "$ENV{'REMOTE_ADDR'} $_[0] ".time()."\n";
  my $mintime = time() - $cfgvars->{cachepurge};
  foreach my $record (@ids) {
    my ($ip, $id, $tm) = split(/\s+/, $record);
    next if $tm < $mintime;
    print CACHE "$ip $id $tm\n";
  }
  truncate(CACHE, tell(CACHE));
  close CACHE;
}
1;