package CASetup;
use CAConfig;
use strict;

my $configvars = {};
my $query = {};

# ======================================================================= setup1

sub setup1 {
  $configvars = $_[0];
  $query = $_[1];
  my $error = "<br><b><font color=red>Error: $_[2]</font></b><br><br>" if $_[2] ne undef;
  my $scriptdir = $configvars->{datadir};
  my $datadir = $query->{datadir};
  print <<EOT;
<center>
<br>
<span class=bigbold>Welcome to Campaign Analyzer Setup Wizard</span>
<br><br>
</center>
<b>Step 1. Setting Data Directory</b>
<br><br>
Campaign Analyzer requires read/write access to some directory in order to
store its data files. The directory must exist and be writeable to Campgaign
Analyzer scripts. Default settings assume usage of the directory you have
uploaded the script to, that is<br>
<br><b>$scriptdir</b><br>
<br>
EOT
  if (! -w $scriptdir) {
    print <<EOT;
Unfortunately this directory is not writeable at the moment and may not be used
to store data files. You may try to change directory permissions (775 or 777
on Unix) and click Retry button below. <b>Please be advised</b> that some
hosting providers do not allow setting 775 and/or 777 access rights for scripts
directory, in such a case you will see Internal Server Error page after clicking
Retry button. You will need to restore access rights for the directory to 755
and run setup again.<br>
<center><form action=$ENV{SCRIPT_NAME} method=post>
<input type=submit value=Retry>
</form></center>
EOT
  } else {
    print <<EOT;
To use the directory above click "Use Default Data Directory" button. <b>Please
be advised</b> that some hosting providers do not allow scripts to write data
into scripts directory, in such a case you will see Internal Server Error page
after clicking on "Use Default Data Directory" button. You will need to restart
Setup Wizard and specify alternate data directory.<br>
<center><form action=$ENV{SCRIPT_NAME} method=post>
<input type=hidden name=cmd value=setup2>
<input type=hidden name=datadir value="$scriptdir">
<input type=submit value="Use Default Data Directory">
</form></center>
EOT
  }
  print <<EOT;
<br>To setup <b>alternate Data Directory</b> please enter absolute filesystem
pathname of the directory. The directory must exist and be writeable to Campaign
Analyzer scripts (set access rights to 777 on Unix). <b>Please be advised</b>
that filesystem pathname is not an URL, that is<br>
<br>
<b>/home/www.mysite.com/htdocs/datadir</b> is a filesystem path, while<br><br>
<b>/datadir</b> and <b>http://www.mysite.com/datadir</b> - are URLs<br>
<center>$error<form action=$ENV{SCRIPT_NAME} method=post>
<input type=hidden name=cmd value=setup2>
<b>Data Directory:</b> <input type=text size=60 name=datadir value="$datadir" class=textinput>
<br><br><input type=submit value="Use Alternate Data Directory">
</form></center>
EOT
}
# ======================================================================= setup2

sub setup2 {
  my $microsoft = $^O eq 'MSWin32';
  $configvars = $_[0];
  $query = $_[1];
  my $dir = $query->{datadir};
  $dir =~ s/\/$//;
  if ($dir eq undef) {
    setup1($_[0], $_[1], "No directory provided");
    return;
  }
  if (!$microsoft && $dir !~ /^\//) {
    setup1($_[0], $_[1], "The directory is not absolute (must begin with '/')");
    return;
  }
  if (! -e $dir) {
    setup1($_[0], $_[1], "Directory $dir does not exist");
    return;
  }
  if (! -d $dir) {
    setup1($_[0], $_[1], "The $dir is a FILE");
    return;
  }
  if (! -w $dir) {
    setup1($_[0], $_[1], "The $dir is not writeable");
    return;
  }
  my $cf = "$dir/".CAConfig::cfgfile();
  if ( -e $cf && ! -w $cf) {
    setup1($_[0], $_[1], "The $dir already contains congif file, which is not writeable");
    return;
  }
  $configvars->{datadir} = $dir;
  if (!CAConfig::save()) {
    setup1($_[0], $_[1], "Error saving config file");
    return;
  }
  my $scrdir = CAConfig::scriptdir();
  if ($dir eq $scrdir) {
    print "<center><br><b>Congratulations! Initial setup completed</b><br><br>".
          "<form action=$ENV{SCRIPT_NAME} method=post><input type=submit value=Continue></form>";
  } else {
    my $dirinfo = CAConfig::dfile();
    print <<EOT;
<center><br>
<b>Configuration file was recorded to<br><br>$dir</b></center>
<br><br>
To complete setup please<br><br>
<b>1.</b> Create text file <b>$dirinfo</b>
<br><br>
<b>2.</b> Copy and paste this text into the <b>$dirinfo</b> file.
<br><br>
<form action=# method=post>
<textarea cols=40 rows=2>
$dir
</textarea>
</form>
<br><br>
<b>3.</b> Upload <b>$dirinfo</b> file into <nobr><b>$scrdir</b></nobr> directory.
<br><br>
<form action=$ENV{SCRIPT_NAME} method=post>
<b>4.</b>
<input type=submit value="Continue"> <b>Warning:</b> Skipping steps 1-3 will
restart Setup Wizard.
</form>
EOT
  }
}
# ==================================================================== setupform

sub setupform {
  $configvars = $_[0];
  $query = $_[1];
  my $sid = $query->{sid};
  my $datadir = $configvars->{datadir};
  my $imgdir = $configvars->{imgdir};
  my $cachewindow = $configvars->{cachewindow};
  my $cachepurge = $configvars->{cachepurge};
  my $ignorevisitors = $configvars->{ignorevisitors};
  my $itemlist = $configvars->{itemlist};
  my $error = "<br><b><font color=red>Error: $_[2]</font></b><br><br>" if $_[2] ne undef;
  print <<EOT;
<center><br><b>System Setup</b><br>
<br>$error
<form action=$ENV{SCRIPT_NAME} method=post>
<input type=hidden name=cmd value=savecfg>
<input type=hidden name=sid value=$sid>
<table border=0 cellpadding=0 cellspacing=0>
<tr><td align=right><b>Data Directory:</b></td><td>&nbsp;&nbsp;$datadir</td></tr>
<tr><td colspan=2 align=center>&nbsp;</td></tr>
<tr height=1><td colspan=2 align=center height=1 bgcolor="#9b9b9b"><img
src="$imgdir/dot.gif" height=1></td></tr>
<tr><td colspan=2><br>
By default all *.gif and *.css files are to be uploaded to Campaign Analyzer
scripts directory. Not all hosting providers allow serving image files
from scripts directory. You may upload *.gif and *.css files to another
directory, please adjust value for "Image Directory URL" field in such a case
- it must contain absolute URL of image directory.<br><br>
</td></tr>
<tr><td align=right><b>Image Directory URL:</b></td><td>&nbsp;&nbsp;
<input type=text size=40 name=imgdir value="$imgdir"></td></tr>
<tr><td colspan=2 align=center>&nbsp;</td></tr>
<tr height=1><td colspan=2 align=center height=1 bgcolor="#9b9b9b"><img
src="$imgdir/dot.gif" height=1></td></tr>
<tr><td colspan=2><br>
In order to track visitors with cookies turned off Campaign Analyzer
maintains cache of issued IDs. If no cookie received from visitor's
browser the script will try to lookup an ID in the cache using
visitor's IP address as a key. For fine tuning cache scheme use
<br><br>
Cache Timeout - time in seconds cached ID:IP pairs are considered to be valid,
all pairs, which are older than $cachewindow are ignored; setting to 0
effectively disables caching.
<br><br>
Cache Purge - time in seconds cached ID:IP pairs are being stored in the cache.<br><br>
</td></tr>
<tr><td align=right><b>Cache Timeout:<br><br></b></td><td>&nbsp;&nbsp;
<input type=text name=cachewindow size=10 value="$cachewindow"><br><br></td></tr>
<tr><td align=right><b>Cache Purge:</b></td><td>&nbsp;&nbsp;
<input type=text name=cachepurge size=10 value="$cachepurge"></td></tr>
<tr><td colspan=2 align=center>&nbsp;</td></tr>
<tr height=1><td colspan=2 align=center height=1 bgcolor="#9b9b9b"><img
src="$imgdir/dot.gif" height=1></td></tr>
<tr><td colspan=2><br>
In order to track visitors Campaign Analyzer assigns unique IDs, which are
being stored in a cookie sent to visitor's browser. You may provide a list
of IDs, which should not be included in reports (such as an ID issued to your
own browser). Please refer to raw log file stored in your Data Directory for
exact values. Separate multiple IDs with a semicolon (;)
<br><br>
</td></tr>
<tr><td align=right><b>Ignore Visitors:</b></td><td>&nbsp;&nbsp;
<input type=text size=60 name=ignorevisitors value="$ignorevisitors" class=textinput></td></tr>
<tr><td colspan=2 align=center>&nbsp;</td></tr>
<tr height=1><td colspan=2 align=center height=1 bgcolor="#9b9b9b"><img
src="$imgdir/dot.gif" height=1></td></tr>
<tr><td colspan=2><br>
You may track sales and leads for individual products (items). You will need
insert proper tracking code for each lead/sale page(s) related to certain
product, please refer to Code menu for more info. In order to enable filtering
in reports you will need provide list of pairs (ItemID,Description). The format
is as follows:
<br><br>
hostgold=>Hosting, Gold Plan
<br><br>
Tracking code for the item is on the left of arrow, product description you want
to be available under Report menu is on the right. Separate multiple items with
a semicolon (;)
<br><br>
</td></tr>
<tr><td align=right><b>Items:</b></td><td>&nbsp;&nbsp;
<input type=text size=60 name=itemlist value="$itemlist" class=textinput></td></tr>
<tr><td colspan=2 align=center>&nbsp;</td></tr>
<tr height=1><td colspan=2 align=center height=1 bgcolor="#9b9b9b"><img
src="$imgdir/dot.gif" height=1></td></tr>
<tr><td colspan=2 align=center>
<br><input type=submit value="Save Settings">
</td></tr>
</table>
</form>
EOT
}
# ====================================================================== savecfg

sub savecfg {
  $configvars = $_[0];
  $query = $_[1];
  my $imgdir = $query->{imgdir};
  $imgdir =~ s/\/$//;
  $imgdir = '.' if $imgdir eq undef;
  $configvars->{imgdir} = $imgdir;
  my $cachewindow = $query->{cachewindow};
  $cachewindow =~ s/ //g;
  $cachewindow = '0' if $cachewindow eq undef;
  if ($cachewindow =~ /[^0-9.]/) {
    setupform($_[0], $_[1], "Invalid Cache Timeout value: $cachewindow");
    return;
  }
  $configvars->{cachewindow} = $cachewindow;
  my $cachepurge = $query->{cachepurge};
  $cachepurge =~ s/ //g;
  $cachepurge = '0' if $cachepurge eq undef;
  if ($cachepurge =~ /[^0-9.]/) {
    setupform($_[0], $_[1], "Invalid Cache Purge value: $cachepurge");
    return;
  }
  $configvars->{cachepurge} = $cachepurge;
  my $ignorevisitors = $query->{ignorevisitors};
  $ignorevisitors =~ s/ //g;
  if ($ignorevisitors =~ /[^0-9A-Z;]/) {
    setupform($_[0], $_[1], "Invalid Ignore Visitors value: $ignorevisitors");
    return;
  }
  $configvars->{ignorevisitors} = $ignorevisitors;
  my $itemlist = {};
  my @items = split(/;/, $query->{itemlist});
  foreach (@items) {
    my ($key, $val) = split(/=>/);
    $key =~ s/\s+/_/g;
    $itemlist->{$key} = $val;
  }
  my $itemline;
  foreach (keys %{$itemlist}) {
    $itemline .= $_."=>".$itemlist->{$_}.";";
  }
  $configvars->{itemlist} = $itemline;
  if (!CAConfig::save()) {
    setupform($_[0], $_[1], "Error saving config file");
    return;
  }
  print "<center><br><b><font color=red>Config file updated</font></b><br><br>\n";
  setupform($_[0], $_[1]);
}
1;