package CAnalyzer;
use strict;
use CAConfig;


my %INPUT;
my $cfgvars = {};
my $cookdomain;
# ================================================================== parseinputs

sub parseinputs {
  my @pairs = split(/&/, $ENV{'QUERY_STRING'});
  foreach my $pair (@pairs) {
    my ($name, $value) = split(/=/, $pair);
    if ($name ne 'referrer') {
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    }
    if ($INPUT{$name} ne undef) { $INPUT{$name} = $INPUT{$name}.",".$value; }
    else { $INPUT{$name} = $value; }
  }
}
# ======================================================================== logit
# logit([event [, newonly]])

sub logit {
  return if !CAConfig::init();
  $cfgvars = CAConfig::getvars();
  $cookdomain = $cfgvars->{cookdomain} if $cfgvars->{cookdomain} ne undef;
  if ($cookdomain eq undef) {
    $cookdomain = $ENV{'HTTP_HOST'};
    $cookdomain =~ s/^www\./\./i;
  }
  parseinputs();
  if ($_[0] eq undef) {
    if ($INPUT{'event'} ne undef) { $_[0] = $INPUT{'event'}; }
    else { $_[0] = '-'; }
  }
  if ($_[1] eq undef) {
    if ($INPUT{'newonly'}) { $_[1] = 1; }
    else { $_[1] = 0; }
  }
  my $visitor = readid();
  if ($visitor eq undef) {
    $visitor = newvisitor();
    logvisit($_[0], $visitor);
  } elsif (!$_[1]) {
    logvisit($_[0], $visitor);
  }
  thedot();
}
# ======================================================================= readid

sub readid {
  my @cooklist = split(/; /,$ENV{'HTTP_COOKIE'});
  foreach (@cooklist) {
    s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    my ($n,$v) = split('=',$_);
    return $v if $n eq $cfgvars->{cookname};
  }
  my $id;
  eval "use CACache";
  if (!$@) {
   $id = CACache::readid();
   if ($id ne undef) {
     print "Set-Cookie: ".$cfgvars->{cookname}."=$id; path=/; domain=$cookdomain; expires=Mon, 28-Dec-2037 00:00:00 GMT\n";
   }
  }
  return $id;
}
# ===================================================================== logvisit

sub logvisit {
  return if $_[1] eq undef;
  my $item = $INPUT{'item'} || '-';
  my $rfr = $INPUT{'referrer'};
  $rfr =~ s/%3A/:/;
  if ($rfr =~ /^[^\/]+:\/\/([^\/]+)/) {
    my $src = $1;
    $src =~ s/\./\\./g;
    $rfr =~ s/($src)/lc($1)/e;
  }
  my $pg = $ENV{'HTTP_REFERER'};
  $pg = '-' if $pg eq undef;
  open(LOG, ">>".$cfgvars->{datadir}."/".$cfgvars->{logfile});
  eval "flock(LOG, 2)";
  seek(LOG, 0, 2);
  print LOG "$_[1] $_[0] $item " . time() . " $ENV{'REMOTE_ADDR'} $pg $rfr\n";
  close(LOG);
}
# ======================================================================= thedot

sub thedot {
  print "Content-type: image/gif\nExpires: Wed, 13-Dec-1995 16:28:32 GMT\n\n";
  open(IMAGE, CAConfig::scriptdir()."/dot.dat");
  while (<IMAGE>) { print $_; }
  close(IMAGE);
}
# =================================================================== newvisitor

sub newvisitor {
  my $id = 1;
  my $cntfile = $cfgvars->{datadir}."/".$cfgvars->{cntfile};
  if (! -e $cntfile) {
    open(IDS, ">$cntfile") || return undef;
    eval "flock(IDS, 2)";
  } else {
    open(IDS, "+<$cntfile") || return undef;
    eval "flock(IDS, 2)";
    if (!seek(IDS, 0, 0)) {
      close(IDS);
      return undef;
    }
    $id = <IDS>;
  }
  if (!seek(IDS, 0, 0)) {
    close(IDS);
    return undef;
  }
  my $newid = incid($id);
  print IDS $newid;
  truncate(IDS, tell(IDS));
  close(IDS);
  print "Set-Cookie: ".$cfgvars->{cookname}."=$id; path=/; domain=$cookdomain; expires=Mon, 28-Dec-2037 00:00:00 GMT\n";
  eval "use CACache";
  CACache::writeid($id) if !$@;
  return $id;
}
# ======================================================================== incid
sub incid {
  my @digits = split(//, $_[0]);
  my $cr = 1;
  for (my $i = $#digits; $cr && ($i >= 0); $i--) {
    $digits[$i] =~ tr/0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ0/;
    $cr = 0 if $digits[$i] ne '0';
  }
  if (!$cr) { return join("", @digits); }
  return "1" . join("", @digits);
}
1;