#!/usr/bin/perl

use strict;
BEGIN {
  if ($^O eq 'MSWin32') {
    eval "use FindBin";
    eval "use lib $FindBin::Bin";
    chdir($FindBin::Bin);
  }
}

eval "use CReporter";
my $edition = 'Pro';
my $hasreporter = 1;
if ($@) {
  eval "use CReporterLite";
  $hasreporter = 0 if $@;
# This is to display correct values only, changes to this code won't help
# Anyway, you may try :o)
  $edition = 'Lite';
}
use CAConfig;
require CASetup;

my $hastimelocal = 0;
eval "use Time::Local";
$hastimelocal = 1 if !$@;

my ($userstart, $systemstart) = times();
my %query;
my @MainMenu = (
  { cmd => ['report','source'], title => 'Report', url => "$ENV{'SCRIPT_NAME'}?cmd=report" },
  { cmd => ['html'], title => 'Code', url => "$ENV{'SCRIPT_NAME'}?cmd=html" },
  { cmd => ['setup1','setup2', 'savecfg', 'setup'], title => 'Setup', url => "$ENV{'SCRIPT_NAME'}?cmd=setup" },
  { cmd => ['logout'], title => 'Logout', url => "$ENV{'SCRIPT_NAME'}?cmd=logout" },
);
my $data = {};
my $users = {};
my $sortfield = 'HIT';
my $sortorder = 0; # 1- Asc, 0 - Desc
my @rowcolor = ('#99ccff', '#aaddff');
my $divclr='#ddeeff';
my $hdrclr='#dddddd';
$|=1;
print "Content-type: text/html\n\n";
my $initcode = CAConfig::error() if !CAConfig::init();
my $cfgvars = {};
$cfgvars = CAConfig::getvars();
my $imgdir = $cfgvars->{imgdir};
my $itemlist = {};
my $isadmin=0;
makeitemlist();
initusers();
parseinputs();
my $the_sid;
if ($query{sid} ne undef) { $the_sid = $query{sid}; }
else {
  srand(time());
  $the_sid = "$query{login}:".int(rand(10000000));
}
if (! exists $query{cmd}) {
  if ($initcode eq 'NeedSetup') { $query{cmd} = 'setup1'; }
  elsif(!%{$users}) { $query{cmd} = 'html'; }
  else { $query{cmd} = 'report'; }
}
header();
if (!$hasreporter) {
  print "<center><br><b>Fatal Error: Reporter module not found</b><br>\n";
  footer();
  exit;
}
if ($initcode) {
  if ($initcode eq 'NeedSetup') {
    if($query{cmd} eq 'savecfg') { savecfg(); }
    elsif($query{cmd} eq 'setup2') { CASetup::setup2($cfgvars, \%query); }
    else { CASetup::setup1($cfgvars, \%query); }
  } else { print "<center><br><b>Error: ".CAConfig::errmsg($initcode)."</b><br>\n"; }
} else {
  if (!validate()) {
    if ($query{cmd} eq 'login') { login(); }
    else { loginform(); }
  } else {
    if ($query{cmd} eq 'report') { report(); }
    elsif  ($query{cmd} eq 'source') { source(); }
    elsif  ($query{cmd} eq 'html') { html(); }
    elsif  ($query{cmd} eq 'logout') { logout(); }
    elsif  ($query{cmd} eq 'savecfg') {
      if ($isadmin) { CASetup::savecfg($cfgvars, \%query); }
      else { print "<center><br><b>ACCESS DENIED</b><br></center>\n"; }
    } elsif  ($query{cmd} eq 'setup') {
      if ($isadmin) { CASetup::setupform($cfgvars, \%query); }
      else { print "<center><br><b>ACCESS DENIED</b><br></center>\n"; }
    }
  }
}
footer();
exit;


# ==================================================================== initusers

sub initusers {
  my @userdefs = split(/;/, $cfgvars->{userlist});
  foreach (@userdefs) {
    my ($login, $passwd) = split(/:/);
    $users->{$login} = $passwd;
  }
}
# ==================================================================== logout

sub logout {
  my ($login) = split(/:/, $the_sid);
  my $sf = $cfgvars->{datadir}."/".$cfgvars->{sidfile}.".$login";
  unlink $sf;
  print "<center><br><b>Thank you for using Campaign Analyzer!</b><br>\n";
}
# ==================================================================== login

sub login {
  if ($query{login} eq undef) {
    loginform("Missing User ID");
    return;
  }
  if ($query{passwd} eq undef) {
    loginform("Missing Password");
    return;
  }
  my $gocode;
  if (!%{$users}) {
    $gocode = 1;
    if ($query{login} =~ /[^A-z0-9]/) {
      loginform("User ID may contain letters and digits only");
      return;
    }
    if ($query{passwd} =~ /[^A-z0-9]/) {
      loginform("Password may contain letters and digits only");
      return;
    }
    if ($query{passwd} ne $query{passwd1}) {
      loginform("Passwords do not match");
      return;
    }
    $cfgvars->{userlist} = "$query{login}:$query{passwd};";
    $cfgvars->{admin} = $query{login};
    $isadmin = 1;
    if (!CAConfig::save()) {
      loginform("Error updating config file");
      return;
    }
  } else {
    if ($users->{$query{login}} ne $query{passwd}) {
      loginform("Wrong User ID or Password");
      return;
    }
  }
  my $sf = $cfgvars->{datadir}."/".$cfgvars->{sidfile}.".$query{login}";
  if (!open(SID, ">$sf")) {
    loginform("Fatal Error: Failed to create session file");
    return;
  }
  my ($session) = (split(/:/, $the_sid))[1];
  print SID "$session\n";
  close SID;
  $query{sid} = $the_sid;
  $isadmin = 1 if $query{login} eq $cfgvars->{admin};
  if ($gocode) { html(); }
  else { $query{rebuild} = 1; report(); }
}
# ==================================================================== loginform

sub loginform {
  my $prompt = 'Please Login';
  my $repeatpasswd;
  if (!%{$users}) {
    $prompt = 'Please Create Admin Account';
    $repeatpasswd =<<EOT;
<tr><td align=right><b>Repeat</b>&nbsp;&nbsp;</td>
<td><input type=password size=15 name=passwd1 value="$query{passwd1}"></td></tr>
EOT
  }
  my $msg = "<b><font color=red>$_[0]</font></b><br><br>\n" if $_[0] ne undef;
  print <<EOT;
<center><br><br>$msg
<form action=$ENV{SCRIPT_NAME} method=post>
<input type=hidden name=cmd value=login>
<table border=0 cellspacing=0 cellpadding=3>
<tr><td colspan=2 align=center><b>$prompt</b></td></tr>
<tr><td align=right><b>User ID</b>&nbsp;&nbsp;</td>
<td><input type=text size=15 name=login value="$query{login}"></td></tr>
<tr><td align=right><b>Password</b>&nbsp;&nbsp;</td>
<td><input type=password size=15 name=passwd value="$query{passwd}"></td></tr>
$repeatpasswd
<tr><td colspan=2 align=center>
<input type=submit value="Login"></td></tr>
</table>
</form>
<br>
EOT
}
# ===================================================================== validate

sub validate {
  return 0 if $query{sid} eq undef;
  my ($login, $session) = split(/:/, $query{sid});
  return 0 if $session eq undef;
  my $sf = $cfgvars->{datadir}."/".$cfgvars->{sidfile}.".$login";
  return 0 if ! -e $sf;
  return 0 if !open(SID, $sf);
  my $sid = <SID>;
  close SID;
  chomp $sid;
  return 0 if $sid ne $session;
  $isadmin = 1 if $login eq $cfgvars->{admin};
  return 1;
}
# ================================================================= makeitemlist

sub makeitemlist {
  my @items = split(/;/, $cfgvars->{itemlist});
  foreach (@items) {
    my ($key, $val) = split(/=>/);
    $itemlist->{$key} = $val;
  }
}
# ======================================================================= html

sub html {
  my $itemsel = "<select name=item>\n<option value=\"\">----- All -----";
  foreach my $item (keys %{$itemlist}) {
    my $selected = ' selected' if $item eq $query{item};
    $itemsel .= "<option value=\"$item\"$selected>".$itemlist->{$item}."\n";
  }
  $itemsel .= "</select>\n";
  my @parts = split(/\//, $ENV{SCRIPT_NAME});
  pop @parts;
  my $cgidir = join('/', @parts);
  my $itemtag = "&item=$query{item}" if $query{item} ne undef;
  my $itemtagcgi = "?item=$query{item}" if $query{item} ne undef;
  print <<EOT;
<center><br><br>
<span class=bigbold>Tracking Code & Instructions</span><br>
<br><br>
<form action="$ENV{SCRIPT_NAME}" method=post>
<input type=hidden name=sid value=$the_sid>
<input type=hidden name=cmd value=html>
Show html code for tracking $itemsel product(s)
<input type=submit value=Submit>
</form>
<table width="90%" border=0>
<tr>
<td>
<b>1. HIT Page Code</b><br>
Add this code to all regular pages, that is the pages visitors enter your site.
Do not place this code on lead or sale pages.
<br><br>
<textarea cols=80 rows=10>
<SCRIPT LANGUAGE="JavaScript">
<!--
var Q="referrer="+escape(window.document.referrer);
document.write('<img border=0 width=1 height=1 src="http://$ENV{HTTP_HOST}$cgidir/hit.cgi?'+Q+'">');
//-->
</SCRIPT>
<NOSCRIPT>
<img src="http://$ENV{HTTP_HOST}$cgidir/hit.cgi" border=0 width=1 height=1>
</NOSCRIPT>
</textarea>
</td>
</tr>
<tr>
<td>
<br><br><b>2. LEAD Page Code</b><br>
Add this code to your lead page(s). The lead page is the one you use to confirm
'lead' event, such as subscription to newsletter, free trial etc.
<br><br>
<textarea cols=80 rows=10>
<SCRIPT LANGUAGE="JavaScript">
<!--
var Q="referrer="+escape(window.document.referrer);
document.write('<img border=0 width=1 height=1 src="http://$ENV{HTTP_HOST}$cgidir/lead.cgi?'+Q+'$itemtag">');
//-->
</SCRIPT>
<NOSCRIPT>
<img src="http://$ENV{HTTP_HOST}$cgidir/lead.cgi$itemtagcgi" border=0 width=1 height=1>
</NOSCRIPT>
</textarea>
</td>
</tr>
<tr>
<td>
<br><br>
<b>3. SALE Page Code</b><br>
Add this code to your sale page(s). The sale page is the one you use to confirm
'sale' event, such as submission of order form or completion of online credit
card transaction.
<br><br>
<textarea cols=80 rows=10>
<SCRIPT LANGUAGE="JavaScript">
<!--
var Q="referrer="+escape(window.document.referrer);
document.write('<img border=0 width=1 height=1 src="http://$ENV{HTTP_HOST}$cgidir/sale.cgi?'+Q+'$itemtag">');
//-->
</SCRIPT>
<NOSCRIPT>
<img src="http://$ENV{HTTP_HOST}$cgidir/sale.cgi$itemtagcgi" border=0 width=1 height=1>
</NOSCRIPT>
</textarea>
</td>
</tr>
<tr>
<td>
<br><br><b>4. Modify referral links (optional)</b><br>
Modify referral links (urls you have submitted to sites generating traffic, such as
Overture.com, Google.com, online catalogs etc.) to provide source info.<br>
<br>
Example:
<br>
If <b>http://www.mydomain.com/welcome.html</b> is the page you assigned to your
advertisement message on Overture, make sure you use
<nobr><b>http://www.mydomain.com/welcome.html?source=Overture</b></nobr>. Campaign
Analyzer checks for 'source' tag ('Source', 'SOURCE', 'sOuRcE' - everything accepted)
in order to build traffic sources table. If no 'source' tag found, referral url
will be analyzed, but usage of 'source' tag guarantees highest level of accuracy.
<br>
</td>
</tr>
</table>
EOT
}
# ======================================================================= source

sub source {
  print "<center><br><br>\n";
  my $options = "&sid=$the_sid&";
  $options .= "showtop=$query{showtop}&" if $query{showtop} ne undef;
  $options .= "item=$query{item}&" if $query{item} ne undef;
  $options .= "countall=$query{countall}&" if $query{countall} ne undef;
  $options .= "starttm=$query{starttm}&" if $query{starttm} ne undef;
  $options .= "endtm=$query{endtm}&" if $query{endtm} ne undef;
  chop($options);
  if ($query{url} eq 'Out-Of-Data-Range') {
    print <<EOT;
<table border=0 width="85%"><tr><td>
The <b>Out-Of-Data-Range</b> is a fictitious source, which is being used to
represent LEAD and SALE events with no matching HIT record. Normally this is a
result of the HIT event logged before current report "Begin Date". Also, the HIT
record may not exist if the pages with LEAD/SALE tracking code may be accessed
directly (e.g. via bookmark or from search engine). Make sure the pages with
LEAD/SALE tracking code may not be accessed directly. Please feel free to
<a href="http://www.eastwright.com/internet/helpdesk/hdform.cgi">contact us</a>
for assistance regarding placement of Campaign Analyzer tracking code.
</td></tr></table>
<br>
<a class=lmenu href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=$query{'orderby'}&sortorder=$query{'sortorder'}$options">Back
to Report</a><br><br>
EOT
    return;
  }
  $data = CReporter::sourcedata($query{'url'}, $query{starttm}, $query{endtm});
  if ($data eq undef) {
    my $e = CReporter::error();
    if ($e ne undef) {
      print "Error: $e\n";
    } else {
      print <<EOT;
No referrer info available for $query{'url'}<br>
<br>
<a class=lmenu href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=$query{'orderby'}&sortorder=$query{'sortorder'}$options">Back
to Report</a><br><br>
EOT
    }
    return;
  }
 print <<EOT;
<span class=bigbold>Referral URLs for source: $query{'url'}</span><br>
<br><a class=lmenu href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=$query{'orderby'}&sortorder=$query{'sortorder'}$options">Back
to Report</a><br><br>
<table border=0 cellspacing=0 cellpadding=0>
<tr bgcolor=$hdrclr>
<td align=center><span class=boldbigwhite>&nbsp;Referrer URL&nbsp;</span></td>
<td width=1 height=13pt bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
<td align=center><span class=boldbigwhite>&nbsp;Hits&nbsp;</span></td>
</tr>
<tr><td colspan=3 height=1><img src="$imgdir/dot.gif" height=1></td></tr>
EOT
  my $clr = 0;
  foreach my $key (keys %{$data}) {
    my $url = $key;
    $url =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $url =~ tr/ /+/;
    if (length($url) > 80) {
      $url = substr($url,0,80)."...";
    }
    my $keyurl = $key;
    $keyurl =~ s/%3A/:/ig;
    $keyurl =~ s/%2E/./ig;
    $keyurl =~ s/%2F/\//ig;
    print "<tr bgcolor=$rowcolor[$clr]><td><span class=smallurl>&nbsp;<a target=_blank ".
          "href=\"$keyurl\">$url</a>&nbsp;</td>".
          "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>".
          "<td align=right>&nbsp;".$data->{$key}."</span>&nbsp;</td>".
          "</tr>\n<tr><td colspan=3 height=1><img src=\"$imgdir/dot.gif\" height=1></td></tr>\n";
    if ($clr) { $clr = 0; }
    else      { $clr = 1; }
  }
print <<EOT;
</table>
<br><span class=lmenu>
<a href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=$query{'orderby'}&sortorder=$query{'sortorder'}$options">Back
to Report</a></span><br>
EOT
}
# ====================================================================== selmday

sub selmday {
  my $buff = "<select name=$_[0]>\n";
  for(my $i = 1; $i < 32; ++$i) {
    my $selected = ' selected' if $i == $_[1];
    $buff .= "<option$selected>$i\n";
  }
  $buff .= "</select>\n";
  return $buff;
}
# ======================================================================= selmon

sub selmon {
  my $buff = "<select name=$_[0]>\n";
  my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
  for(my $i = 0; $i < 12; ++$i) {
    my $selected = ' selected' if $i == $_[1];
    $buff .= "<option value=$i$selected>$months[$i]\n";
  }
  $buff .= "</select>\n";
  return $buff;
}
# ==================================================================== printyear

sub printyear {
  return $_[0] + 1900;
}
# ====================================================================== selyear

sub selyear {
  my $buff = "<select name=$_[0]>\n";
  my ($end) = (localtime)[5];
  $end = 137 if $end > 137;
  my $start = $_[1] - 5;
  $start = 70 if $start < 70;
  for(my $i = $start; $i <= $end; ++$i) {
    my $selected = ' selected' if $i == $_[1];
    $buff .= "<option value=$i$selected>".printyear($i)."\n";
  }
  $buff .= "</select>\n";
  return $buff;
}
# ======================================================================= winsel

sub winsel {
  print <<EOT;
<form action="$ENV{SCRIPT_NAME}" method=post>
<input type=hidden name=sid value=$the_sid>
<input type=hidden name=item value="$query{item}">
<input type=hidden name=starttm value="$query{starttm}">
<input type=hidden name=endtm value="$query{endtm}">
<input type=hidden name=countall value="$query{countall}">
<input type=hidden name=cmd value=report>
<input type=hidden name=orderby value="$query{orderby}">
<input type=hidden name=sortorder value="$query{sortorder}">
&nbsp;Show top <select name=showtop>
EOT
  $query{showtop} = 20 if $query{showtop} eq undef;
  foreach ('10', '20', '50', '100', '200') {
    my $selected = ' selected' if $_ == $query{showtop};
    print "<option$selected>$_\n";
  }
  print <<EOT;
</select>
records
<input type=submit value=Go>
EOT
}
# ===================================================================== controls

sub controls {
  my $litemsg = "<center>(<b>Begin/End Dates</b> and <b>\"repeat sales/leads\"</b> checkbox are not supported in Lite version)</center>\n"
    if $edition ne 'Pro';
  my $itemsel = "<select name=item>\n<option value=\"\">----- All -----";
  foreach my $item (keys %{$itemlist}) {
    my $selected = ' selected' if $item eq $query{item};
    $itemsel .= "<option value=\"$item\"$selected>".$itemlist->{$item}."\n";
  }
  $itemsel .= "</select>\n";
  my $checked = ' checked' if $query{countall};
  print <<EOT;
<table border=0 cellspacing=0 cellpadding=0>
<tr>
<td>
<form action="$ENV{SCRIPT_NAME}" method=post>
<input type=hidden name=rebuild value=1>
<input type=hidden name=sid value=$the_sid>
<input type=hidden name=cmd value=report>
<input type=hidden name=showtop value="$query{showtop}">
<input type=hidden name=orderby value="$query{orderby}">
<input type=hidden name=sortorder value="$query{sortorder}">
Show results for $itemsel product(s),
&nbsp;&nbsp;&nbsp;<input type=checkbox name=countall$checked>
include repeat sales/leads<br><span class=smallbr><br></span><center>
EOT
  if ($hastimelocal) {
    my ($startmday, $startmon, $startyear, $endmday,$endmon,$endyear);
    my $starttm = time() - 30*24*60*60; $starttm = $query{starttm} if $query{starttm} ne undef;
    my $endtm = time(); $endtm = $query{endtm} if $query{endtm} ne undef;
    ($startmday, $startmon, $startyear) = (gmtime($starttm))[3,4,5];
    ($endmday, $endmon, $endyear) = (gmtime($endtm))[3,4,5];
    my $startmdaysel = selmday('startmday', $startmday);
    my $startmonsel = selmon('startmon', $startmon);
    my $startyearsel = selyear('startyear', $startyear);
    my $endmdaysel = selmday('endmday', $endmday);
    my $endmonsel = selmon('endmon', $endmon);
    my $endyearsel = selyear('endyear', $endyear);
    print <<EOT;
</center>
Begin Date: $startmdaysel $startmonsel $startyearsel
End Date: $endmdaysel $endmonsel $endyearsel
EOT
  }
print <<EOT;
&nbsp;&nbsp;<input type=submit value=Recalc></center>
$litemsg
</form>
</td>
</tr>
</table>
<span class=smallbr><br></span>
EOT
}
# ======================================================================= report

sub report {
  my $litemsg = "<center><span class=normaltext><b>Note:</b> All sales and leads are shown as ".
                "of \"Unknown\" source in <b>Lite</b> version.<br>".
                "For upgrade info please visit ".
                "<a href=\"http://www.eastwright.com/internet/ca/index.html\">Campaign".
                " Analyzer</a> page.</span></center>\n"
    if $edition ne 'Pro';
  print <<EOT;
<center>
<br>
<script language=Javascript>
function si(source)
{
 var formid = "sourceinfo";
 document.forms[formid].url.value=source;
 document.forms[formid].submit();
 return false;
}
</script>
<form action="$ENV{'SCRIPT_NAME'}" method=post name=sourceinfo>
<input type=hidden name=sid value=$the_sid>
<input type=hidden name=cmd value=source>
<input type=hidden name=url>
<input type=hidden name=showtop value="$query{showtop}">
<input type=hidden name=item value="$query{item}">
<input type=hidden name=countall value="$query{countall}">
<input type=hidden name=starttm value="$query{starttm}">
<input type=hidden name=endtm value="$query{endtm}">
<input type=hidden name=orderby value="$query{orderby}">
<input type=hidden name=sortorder value="$query{sortorder}">
</form>
EOT
  controls();
  $data = CReporter::report($query{item}, $query{countall}, $query{starttm}, $query{endtm}, $query{rebuild});
  my $reporttime = CReporter::rtime();
  if ($data eq undef) {
    my $e = CReporter::error();
    if ($e ne undef) {
      print "<b>Error: $e</b>\n";
    } else {
      print "<b>No sales/leads data collected</b>\n";
    }
    return;
  }
  my $options="&sid=$the_sid&";
  $options .= "showtop=$query{showtop}&" if $query{showtop} ne undef;
  $options .= "item=$query{item}&" if $query{item} ne undef;
  $options .= "coutnall=$query{countall}&" if $query{countall} ne undef;
  $options .= "starttm=$query{starttm}&" if $query{starttm} ne undef;
  $options .= "endtm=$query{endtm}&" if $query{endtm} ne undef;
  chop($options);
  print "<center><b>Report Time: ".CReporter::rtime()."</b><br><br></center>\n";
  print <<EOT;
<table border=0 cellspacing=0 cellpadding=0>
<tr>
<td width=1 height=26pt><img src="$imgdir/dot.gif" width=1></td>
<td colspan=3 valign=top>
EOT
  winsel();
  print <<EOT;
</td>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
<td bgcolor=$hdrclr colspan=2 align=center><span class=boldbigwhite>Leads</span></td>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
<td bgcolor=$hdrclr colspan=3 align=center><span class=boldbigwhite>Sales</span></td>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
</tr></form>
<tr bgcolor=$hdrclr>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
<td height=13pt><span class=boldbigwhite>&nbsp;Source</span>
<a href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SOURCE&sortorder=1$options"><img src="$imgdir/up.gif"
border=0 alt="Sort Ascending"></a><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SOURCE&sortorder=0$options"><img
src="$imgdir/dn.gif" border=0 alt="Sort Descending"></a>
</td>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
<td align center><span class=boldbigwhite>&nbsp;Visits&nbsp;</span><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=HIT&sortorder=1$options"><img src="$imgdir/up.gif"
border=0 alt="Sort Ascending"></a><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=HIT&sortorder=0$options"><img
src="$imgdir/dn.gif" border=0 alt="Sort Descending"></a>
</td>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
<td align=center><span class=boldwhite>&nbsp;Total</span>
<a href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=LEAD&sortorder=1$options"><img src="$imgdir/up.gif"
border=0 alt="Sort Ascending"></a><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=LEAD&sortorder=0$options"><img
src="$imgdir/dn.gif" border=0 alt="Sort Descending"></a>
</td>
<td align=center><span class=boldwhite>&nbsp;L/H</span>
<a href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=LH&sortorder=1$options"><img src="$imgdir/up.gif"
border=0 alt="Sort Ascending"></a><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=LH&sortorder=0$options"><img
src="$imgdir/dn.gif" border=0 alt="Sort Descending"></a>
</td>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
<td align=center><span class=boldwhite>&nbsp;Total</span>
<a href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SALE&sortorder=1$options"><img src="$imgdir/up.gif"
border=0 alt="Sort Ascending"></a><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SALE&sortorder=0$options"><img
src="$imgdir/dn.gif" border=0 alt="Sort Descending"></a>
</td>
<td align=center><span class=boldwhite>&nbsp;&nbsp;S/H</span>
<a href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SH&sortorder=1$options"><img src="$imgdir/up.gif"
border=0 alt="Sort Ascending"></a><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SH&sortorder=0$options"><img
src="$imgdir/dn.gif" border=0 alt="Sort Descending"></a>
</td>
<td align=center><span class=boldwhite>&nbsp;&nbsp;S/L</span>
<a href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SL&sortorder=1$options"><img src="$imgdir/up.gif"
border=0 alt="Sort Ascending"></a><a
href="$ENV{'SCRIPT_NAME'}?cmd=report&orderby=SL&sortorder=0$options"><img
src="$imgdir/dn.gif" border=0 alt="Sort Descending"></a>
</td>
<td width=1 bgcolor=$divclr><img src="$imgdir/dot.gif" width=1></td>
</tr>
<tr><td colspan=12 height=1><img src="$imgdir/dot.gif" height=1></td></tr>
EOT
  my %totals;
  my ($lh, $sl, $sh);
  my $clr = 0;
  my @list;
  my $key;
  my $ptr = {};
  while (($key, $ptr) = each %{$data}) {
    if ($ptr->{HIT} > 0) {
      if ($ptr->{LEAD}) {
        $ptr->{LH} = $ptr->{LEAD} / $ptr->{HIT} * 100;
      } else {
        $ptr->{LH} = '-&nbsp;&nbsp;&nbsp;';
      }
      if ($ptr->{SALE}) {
        $ptr->{SH} = $ptr->{SALE} / $ptr->{HIT} * 100;
      } else {
        $ptr->{SH} = '-&nbsp;&nbsp;&nbsp;';
      }
    } else {
      $ptr->{SH} = '-&nbsp;&nbsp;&nbsp;';
      $ptr->{LH} = '-&nbsp;&nbsp;&nbsp;';
    }
    if ($ptr->{LEAD} > 0 && $ptr->{SALE} > 0) {
      $ptr->{SL} = $ptr->{SALE} / $ptr->{LEAD} * 100;
    } else {
      $ptr->{SL} = '-&nbsp;&nbsp;&nbsp;';
    }
  }
  $sortfield = $query{orderby} if $query{orderby} ne undef;
  $sortorder = $query{sortorder} if $query{sortorder} ne undef;
  if ($sortfield eq 'HIT') {
    if ($sortorder) {
      @list = sort {$data->{$a}->{HIT} <=> $data->{$b}->{HIT}} keys %{$data};
    } else {
      @list = sort {$data->{$b}->{HIT} <=> $data->{$a}->{HIT}} keys %{$data};
    }
  } elsif ($sortfield eq 'LEAD') {
    if ($sortorder) {
      @list = sort {$data->{$a}->{LEAD} <=> $data->{$b}->{LEAD}} keys %{$data};
    } else {
      @list = sort {$data->{$b}->{LEAD} <=> $data->{$a}->{LEAD}} keys %{$data};
    }
  } elsif ($sortfield eq 'SALE') {
    if ($sortorder) {
      @list = sort {$data->{$a}->{SALE} <=> $data->{$b}->{SALE}} keys %{$data};
    } else {
      @list = sort {$data->{$b}->{SALE} <=> $data->{$a}->{SALE}} keys %{$data};
    }
  } elsif ($sortfield eq 'LH') {
    if ($sortorder) {
      @list = sort {$data->{$a}->{LH} <=> $data->{$b}->{LH}} keys %{$data};
    } else {
      @list = sort {$data->{$b}->{LH} <=> $data->{$a}->{LH}} keys %{$data};
    }
  } elsif ($sortfield eq 'SH') {
    if ($sortorder) {
      @list = sort {$data->{$a}->{SH} <=> $data->{$b}->{SH}} keys %{$data};
    } else {
      @list = sort {$data->{$b}->{SH} <=> $data->{$a}->{SH}} keys %{$data};
    }
  } elsif ($sortfield eq 'SL') {
    if ($sortorder) {
      @list = sort {$data->{$a}->{SL} <=> $data->{$b}->{SL}} keys %{$data};
    } else {
      @list = sort {$data->{$b}->{SL} <=> $data->{$a}->{SL}} keys %{$data};
    }
  } elsif ($sortfield eq 'SOURCE') {
    if ($sortorder) {
      @list = sort keys %{$data};
    } else {
      @list = sort { $b cmp $a} keys %{$data};
    }
  } else {
    @list = keys %{$data};
  }
  my $showtop = ($query{showtop} || 20);
  foreach my $source (@list) {
    $ptr = $data->{$source};
    $lh = $ptr->{LH};
    $lh = sprintf("%.2f\%", $lh) if $lh > 0;
    $sh = $ptr->{SH};
    $sh = sprintf("%.2f\%", $sh) if $sh > 0;
    $sl = $ptr->{SL};
    $sl = sprintf("%.2f\%", $sl) if $sl > 0;
    my $lead = $ptr->{LEAD} || '-';
    my $sale = $ptr->{SALE} || '-';
    my $stitle = $source;
    if (length($stitle) > 30) {
      $stitle = substr($stitle,0,30)."...";
    }
    print "<tr bgcolor=$rowcolor[$clr]>".
          "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
          "<td height=11pt>&nbsp;<span class=boldlink>".
          "<a href=# onClick=\"return si('$source')\">$stitle</a></span>&nbsp;</td>".
          "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
          "<td align=right>&nbsp;".$data->{$source}->{HIT}."&nbsp;&nbsp;&nbsp;&nbsp;".
          "&nbsp;</td><td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
          "</td><td align=right>&nbsp;".
          "$lead&nbsp;&nbsp;&nbsp;&nbsp;</td><td align=right>&nbsp;$lh&nbsp;</td>".
          "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
          "<td align=right>&nbsp;$sale&nbsp;&nbsp;&nbsp;&nbsp;</td>".
          "<td align=right>&nbsp;$sh</td><td align=right>&nbsp;&nbsp;$sl&nbsp;</td>".
          "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
          "</tr>\n";
    $totals{HIT} += $ptr->{HIT};
    $totals{LEAD} += $ptr->{LEAD};
    $totals{SALE} += $ptr->{SALE};
    print "<tr><td colspan=12 height=1><img src=\"$imgdir/dot.gif\" height=1></td></tr>\n";
    if ($clr) { $clr = 0; } else { $clr = 1; }
    if ($query{showtop} ne undef) {
      $showtop--;
      last if !$showtop;
    }
  }
  if ($totals{HIT} > 0) {
    $lh = sprintf("%.2f\%", $totals{LEAD}/$totals{HIT}*100);
    $sh = sprintf("%.2f\%", $totals{SALE}/$totals{HIT}*100);
  } else {
    $lh = '100%';
    $sh = '100%';
  }
  if ($totals{LEAD} > 0) {
    $sl = sprintf("%.2f\%", $totals{SALE}/$totals{LEAD}*100);
  } else {
    $sl = 'N/A';
  }
  print "<tr bgcolor=$rowcolor[$clr]>".
        "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
        "<td><b>&nbsp;Total</b></td>\n".
        "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
        "<td align=right>&nbsp;<b>$totals{HIT}</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>\n".
        "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
        "<td align=right>&nbsp;<b>$totals{LEAD}</b>&nbsp;&nbsp;&nbsp;&nbsp;</td>\n".
        "<td align=right>&nbsp;<b>$lh&nbsp;</b></td>\n".
        "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
        "<td align=right>&nbsp;<b>$totals{SALE}</b>&nbsp;&nbsp;&nbsp;&nbsp;</td>\n".
        "<td align=right>&nbsp;<b>$sh</b></td>\n".
        "<td align=right>&nbsp;&nbsp;<b>$sl&nbsp;</b></td>".
        "<td width=1 bgcolor=$divclr><img src=\"$imgdir/dot.gif\" width=1></td>\n".
        "</tr>\n</table>\n<br>$litemsg";
}
# ================================================================== parseinputs

sub parseinputs {
  my @pairs = split(/&/, $ENV{'QUERY_STRING'});
  my $buffer;
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  @pairs = (@pairs, split(/&/, $buffer));
  foreach (@pairs) {
    my ($name, $value) = split(/=/);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    if ($query{$name} ne undef) { $query{$name} .= ",$value"; }
    else { $query{$name} = $value; }
  }
  if ($query{showtop} ne undef) {
    $query{showtop} = undef if $query{showtop} !~ /^\d+$/;
  }
  $query{showtop} = 20 if $query{showtop} eq undef;
  if ($hastimelocal) {
    if ($query{startmday} ne undef) {
      $query{starttm} = timegm(0, 0, 0, $query{startmday}, $query{startmon}, $query{startyear});
    }
    if ($query{endmday} ne undef) {
      $query{endtm} = timegm(59, 59, 23, $query{endmday}, $query{endmon}, $query{endyear});
    }
    if ($query{endtm} ne undef && $query{starttm} > $query{endtm}) {
      $query{endtm} = $query{starttm} + 24 * 60 * 60 - 1;
    }
  }
  if ($edition ne 'Pro') {
# This is to display correct values only, removal of this code won't help
# Anyway, you may try :o)
    $query{countall} = 1;
    $query{starttm} = 0;
    $query{endtm} = time()+3600;
  }
}
# ======================================================================= header

sub header {
  print <<EOT;
<html>
<head>
<title>
Campaign Analyzer
</title>
<link rel=stylesheet href=$imgdir/style.css type=text/css>
</head>
<body leftMargin=0 topMargin=0 marginHeight=0 marginWidth=0>
<center><span class=smallbr><br></span>
<table width=780 border=0 cellpadding=0 cellspacing=0><tr>
<td width=1  height="18pt" bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
<td width=778 bgcolor="#336699"><span class=topbar>&nbsp;
Campaign Analyzer $edition&nbsp;&nbsp;rev. 2.04
</span></td>
<td width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
</tr></table>
<table width=780 border=0 cellpadding=0 cellspacing=0><tr>
<td width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
<td width=778>
  <table width=778 border=0 cellpadding=0 cellspacing=0  height="22pt"><tr>
EOT
  my $padwidth = 778;
  foreach my $item (@MainMenu) {
    my $title = $item->{title};
    my $url = $item->{url};
    if (grep(/^$query{cmd}$/, @{$item->{cmd}})) {
      print <<EOT;
<td width=100 align=center bgcolor="#f8f8f9">
<table border=0 cellpadding=0 cellspacing=0 width=100 height="20pt">
<tr><td width=1 rowspan=3 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
<td width=98 bgcolor="#9b9b9b" height=1><img src="$imgdir/dot.gif" width=98 height=1></td>
<td rowspan=3 width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
</tr>
<tr><td height="18pt" width=98><center>
<b><font class=mainmenusel>$title</font></td></tr>
<tr>
<td width=98 bgcolor="#efefef" height=1><img src="$imgdir/dot.gif" width=98 height=1></td>
</tr>
</table>
</td>
EOT
    } else {
      print <<EOT;
<td width=100 align=center bgcolor="#ffffff">
<table border=0 cellpadding=0 cellspacing=0 width=100 height="20pt">
<tr><td width=1 rowspan=3 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
<td width=98 bgcolor="#cacaca" height=1><img src="$imgdir/dot.gif" width=98 height=1></td>
<td rowspan=3 width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td></tr>
<tr><td width=98 height="18pt" bgcolor="#eaeaea">
<center><span class=mainmenu><a href="$url&sid=$the_sid">$title</a></span></td></tr>
<tr>
<td width=98 bgcolor="#9b9b9b" height=1><img src="$imgdir/dot.gif" width=98 height=1></td>
</tr>
</table>
</td>
EOT
    }
    print "<td width=1 bgcolor=\"#fafafa\"><img src=\"$imgdir/dot.gif\" width=1></td>\n";
    $padwidth -= 101;
  }
  my $padwidth2 = $padwidth - 2;
  print <<EOT;
<td width=$padwidth align=center bgcolor="#ffffff">
<table width=$padwidth border=0 cellpadding=0 cellspacing=0 height="20pt">
<tr><td width=1 rowspan=3 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
<td width=$padwidth2 bgcolor="#cacaca" height=1><img src="$imgdir/dot.gif"
width=$padwidth2 height=1></td>
<td rowspan=3 width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
</tr>
<tr>
<td height="18pt" width=$padwidth2 bgcolor="#eaeaea">
&nbsp;
</td>
</tr>
<tr>
<td width=$padwidth2 bgcolor="#9b9b9b" height=1><img src="$imgdir/dot.gif"
width=$padwidth2 height=1></td>
</tr>
</table>
</td>
</tr></table>
</td>
<td width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
</tr></table>
<table width=780 border=0 cellpadding=0 cellspacing=0><tr>
<td width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
<td width=10 bgcolor="#ffffff"><img src="$imgdir/dot.gif" width=10></td>
<td width=758>
EOT
}
# ======================================================================= footer

sub footer {
  my ($userend, $systemend) = times();
  $userend -= $userstart;
  $systemend -= $systemstart;
  my $runtime = sprintf("Run time: %.2fs", $userend+$systemend);
  print <<EOT;
<br><br>
  </td>
<td width=10 bgcolor="#ffffff"><img src="$imgdir/dot.gif" width=10></td>
<td width=1 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
</tr></table>
<table width=780 border=0 cellpadding=0 cellspacing=0><tr>
<td width=1 rowspan=2 height="18pt" bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
<td width=778 bgcolor="#cacaca"><span class=copyright>&nbsp;
(c) 2002 - 2004, <a href="http://www.eastwright.com">Eastwright Corp</a>
&nbsp;::&nbsp;&nbsp;$runtime
</span></td>
<td width=1 rowspan=2 bgcolor="#9b9b9b"><img src="$imgdir/dot.gif" width=1></td>
</tr>
<tr><td height=1 width=778 bgcolor="#9b9b9b"><img src=\"$imgdir/dot.gif\" height=1 width=778></td></tr>
</table>
<br>
</body>
</html>
EOT
}